﻿
#ラベル付き隣接行列:networkを表現
m = [
    [0,2,1,4,0],   # A (0)
    [2,0,0,3,0],   # B (1)
    [1,0,0,2,4],   # C (2)
    [3,3,2,0,1],   # D (3)
    [0,0,4,1,0],   # E (4)
    ]
#初期設定
max_cost = float('inf')      #無限大
m_node = len(m)              #ノード数は隣接行列によって求める
unchecked = [False] * m_node #未確定ノードの集合
cost = [max_cost] * m_node   #起点から各ノードへの最小費用
f_prev = [None] * m_node     #最短経路を列挙するための配列

def search(m,ori,des):     #ネットワークｍにおいて起点oriから目的地desまでの最短経路を探す
    cost[ori] = 0          # 起点のノードの距離は０とする
    f_prev[ori] = ori      #起点前のノードは起点とする
    now = ori              #現在地を起点とする
    
    while True:
        min = max_cost     #変数minは現段階の最小費用を表す（初期は無限大）
        next = -1          #nextは起点から最小費用のあるノードを表す(初期－1)
        unchecked[now] = True
        for i in range(m_node):        #変数iはノード（0~4）
            if unchecked[i]: continue  #ノードが確定しいない場合ループが続く
            if m[now][i]:              #今のノードiと起点(now=ori)が接続しているかどうか
                tmp_cost = m[now][i] + cost[now] #一時的の費用を計算し、最小費用の更新
                if cost[i] > tmp_cost:
                    cost[i] = tmp_cost
                    f_prev[i] = now    #直前のノードに更新
            if min > cost[i]:          #現段階の最小費用と最小費用を持つノードを更新
                min = cost[i]
                next = i
        now = next                    #確定された最小費用持つノードが新らい”起点”となる
        if next == -1: break          #ノード番号が－1なるまで(すべてノードが確認される)
        
    print_path(f_prev, cost)          #各接続しているノード間ルートの費用
    return [get_path(ori, des, f_prev), cost[des]]

#結果の出力

def print_path(f_prev, cost):
    for i in range(len(f_prev)):
        print("%d, prev = %d, cost = %d" %  (i, f_prev[i], cost[i]))

def get_path(ori, des, f_prev):
    path = []
    now = des
    path.append(now)
    while True:
        path.append(f_prev[now])      # f_prevには一つ前のノードが入ってる。
        if f_prev[now] == ori: break  #格納されたノードを逆にたどっていっけば経路が求められる
        now = f_prev[now]
    path.reverse()
    return path


path, cost = search(m, 0, 4)
print('path:',path)
print('cost:',cost)
